/*
Network motif analysis tools
Copyright (C) 2006 Johannes Knabe
j.f.knabe@herts.ac.uk

Free for you to use in any way, but acknowledgement / reference has to be given.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

import java.io.*;
import java.util.*;


public class main{

public static int subnetsize=3;
public static int watchForThisCanonic=-1;//set to -1 to get rid of annoying outputs //4369
public static final boolean considerInhibitory=false;
public static final boolean environmentAsNode=false;
public static final boolean differentiationAsNode=false;
public static java.util.Random rand=new java.util.Random(23051981);

public static String[] split(String what, String delim){
StringTokenizer x=new StringTokenizer(what,delim,true);
Vector y=new Vector();
//String[] ret=new String[x.countTokens()];
int max=x.countTokens();
String t;
int last=-1;
     for(int i=0;i<max;i++) {
         t=x.nextToken();
         if(t.equals(delim)){
           if(last==i-1){
             y.add("");
             }
           last=i;
           }
         else
           y.add(t);
     }
String[] ret=new String[y.size()];
     for(int i=0;i<ret.length;i++) {
         ret[i]=""+y.elementAt(i);
     }
return ret;
}



public static int[] stringToIntArr(String in){
int[] ret=new int[in.length()];
int j=0;
for(int i=0;i<ret.length;i++)
 try{
  ret[j]=Integer.parseInt(""+in.charAt(i));
  j++;
 }catch(Exception e){}
int[] ret2=new int[j];
System.arraycopy(ret,0,ret2,0,j);
return ret2;
}

public static int getMostSignificantMotif(double[] c1, double[] c2, double[] stdDevs,int subnetsize){
int best=-1;
double Z=0.0;
for(int i=0;i<c1.length;i++)
  if((c2[i]>0.01)&&((c1[i]-c2[i])>stdDevs[i])&&!badSubNet(network.canonicalIntToConnMat(i,subnetsize*subnetsize))){
   //System.out.println("The network with canonical number "+i+" has been found on avg. "+c1[i]+" and "+c2[i]+" times, a difference of "+(c1[i]-c2[i]+" that is "+((c1[i]-c2[i])/stdDevs[i])+" Z (std.dev. "+stdDevs[i]));
   if(((c1[i]-c2[i])/stdDevs[i])>Z){
    Z=((c1[i]-c2[i])/stdDevs[i]);
    best=i;
    }
   }
//System.out.println("Best motif: "+best+" was found "+c1[best]+" times and had Z value: "+Z);
//network.printConnectivityMatrix(network.canonicalIntToConnMat(best,subnetsize*subnetsize));
return best;
}

public static void compare(double[] c1, double[] c2, double[] stdDevs,int subnetsize){
/*NORMALIZING SHOULD NO LONGER BE NEEDED AS WE NOW EXPECT THE Ci DOUBLE[] TO BE AVGs
//do we need to normalize?
double c1Sum=0;
for(int i=0;i<c1.length;i++){
  c1Sum+=c1[i];
}
double c2Sum=0;
for(int i=0;i<c1.length;i++){
  c2Sum+=c2[i];
}
if(c1Sum>c2Sum){
  double ratio=c1Sum/c2Sum;
  for(int i=0;i<c1.length;i++){
   c1[i]/=ratio;
  }
 }
else
 if(c1Sum<c2Sum){
  double ratio=c2Sum/c1Sum;
  for(int i=0;i<c1.length;i++){
   c2[i]/=ratio;
  }
 }


c1Sum=0;
for(int i=0;i<c1.length;i++){
  c1Sum+=c1[i];
}
c2Sum=0;
for(int i=0;i<c1.length;i++){
  c2Sum+=c2[i];
}
System.out.println("Sums after normalizing: "+c1Sum+" and "+c2Sum);
*/

//output results
for(int i=0;i<c1.length;i++)
  if((i==watchForThisCanonic)||((c1[i]-c2[i])>stdDevs[i])){//limit too extreme???
   System.out.println("------------------------------------------------");
   System.out.println("The network with canonical number "+i+" has been found on avg. "+c1[i]+" and "+c2[i]+" times, a difference of "+(c1[i]-c2[i]+" that is "+((c1[i]-c2[i])/stdDevs[i])+" Z (std.dev. "+stdDevs[i]));
   
   network.printConnectivityMatrix(network.canonicalIntToConnMat(i,subnetsize*subnetsize));
   System.out.print("------------------------------------------------");
  //System.out.println(i+": "+cnt[i]);
  }
System.out.println("------------------------------------------------");
}

public static double getAvgDensity(Vector<int[][]> nets){
double sum=0;
for(int[][] nework: nets){
  sum+=network.getDensity(nework);
  }
double avg=sum/(nets.size()*1.0);
double diffSum=0;
for(int[][] nework: nets){
  double diff=(network.getDensity(nework)-avg);
  diffSum+=diff*diff;
  }
double sigma=Math.sqrt(diffSum/nets.size());
double stdErr=sigma/Math.sqrt(nets.size());
System.out.println("Density: "+avg+" +/- "+sigma+" ("+stdErr+" std.err.)");
return avg;
}

public static void doModularityAnalysis(Vector<int[][]> nets){
doModularityAnalysis(nets,false);
}

public static void doModularityAnalysis(Vector<int[][]> nets,boolean checkModuleStructure){
double sumMaxModularity=0;
double sumModuleNumber= 0;
double[] canonicModules=null;
if(checkModuleStructure)
  canonicModules=new double[(int)Math.pow(2,subnetsize*subnetsize)];
double[] modNumBuffer=new double[nets.size()];
int jk=0;
for(int[][] nework: nets){
 double[] res=network.getMaximumModularity(nework);
 sumMaxModularity+=res[0];
 sumModuleNumber +=res.length-1;
 modNumBuffer[jk++]=res.length-1; //buffer values so that we can later calculate std.dev.
 if(checkModuleStructure){//begin checkModuleStructure
  for(int i=0;i<res.length-1;i++){
   network ttt=new network(nework);
   int[] part=new int[res.length-1];
   for(int j=0;j<part.length;j++)
     part[j]=(int)res[j+1];
   ttt.partition(part);
   if(res[i+1]==subnetsize){//this subnetwork has the size we are looking for, check it
    int t=network.getCanonicalInt(ttt.getSubclassConnectivityMatrixArray(i));
    canonicModules[t]++;
    }
   }
  }//end checkModuleStructure
 }//end for nets
 
double avgModNum=(sumModuleNumber/(double)nets.size());
//calculate module number std.dev.
double diffSum=0;
for(int i=0;i<modNumBuffer.length;i++)
  diffSum+=(modNumBuffer[i]-avgModNum)*(modNumBuffer[i]-avgModNum);
double modNumSigma=Math.sqrt(diffSum/(double)nets.size());

 if(checkModuleStructure) //output checkModuleStructure results
  for(int i=0;i<canonicModules.length;i++)
   if(canonicModules[i]>0){
    System.out.println("+++++++++++++++++++++++++++++++++++++++++++++++");
    System.out.println("The network with canonical number "+i+" has been considered a module "+canonicModules[i]+" times");
    network.printConnectivityMatrix(network.canonicalIntToConnMat(i,subnetsize*subnetsize));
    System.out.print("+++++++++++++++++++++++++++++++++++++++++++++++");
   }
System.out.println("The networks have an avg. maximum modularity of: "+(sumMaxModularity/(double)nets.size())+
                   " with an avg. number of modules of: "+avgModNum+" +/- "+modNumSigma);
}

public static void modularityTest(){
network test=new network(6);
test.addNodes(6);
test.link(0,0);
test.link(0,1);
test.link(1,1);
test.link(1,2);
test.link(0,2);
test.link(2,1);
test.link(2,0);

test.link(3,4);
test.link(3,3);
test.link(4,3);
test.link(4,4);
test.link(5,3);
test.link(5,4);
test.link(3,5);

test.link(3,2);
test.link(2,3);

/*test.partition(new int[]{3,3});
test.printConnectivityMatrix();
network.printConnectivityMatrix(test.getSubclassConnectivityMatrixArray(0));
network.printConnectivityMatrix(test.getSubclassConnectivityMatrixArray(1));
*/
double[] res=test.getMaximumModularity(test.getConnectivityMatrixArray());
test.printConnectivityMatrix();
System.out.print("Maximum modularity for above network:");
for(int i=0;i<res.length;i++)
  System.out.print(res[i]+",");
System.out.println();
}

public static double[] an(Vector<int[][]> nets2){
return an(nets2,null,null);
}

//This function does the analysis of one directory for you, pattern occurences
//numbers are counted and returned as double[], if not null as parameter then
//pattern occurences in randomized nets are counted into motifsWhenRandomized[],
//finally, to make it real motifs we need to know the std.deviations of pattern
//occurences in the nets

//this will return true when the first node of this network has no output and no input
//that is useful because unconnected nodes are not of interest almost always
public static boolean badSubNet(int[][] ret){
          boolean kickout=true;
          for(int i=0;i<ret[0].length;i++){
           if(ret[0][i]!=0)
            kickout=false;
           if(ret[i][0]!=0)
            kickout=false;
           }
          int ccc=0;
          for(int i=0;i<ret.length;i++)
           for(int j=0;j<ret[0].length;j++)
            if(ret[i][j]!=0)
             ccc++;
          if(ccc<3)//not enough connections, somebody is not in!
            kickout=true;
          if(kickout)
            return true;
return false;
}

public static double[] an(Vector<int[][]> nets2,double[] motifsWhenRandomized, double[] motifStdDevs){
return an(nets2,motifsWhenRandomized,motifStdDevs,null,null,null);
}

public static double[] an(Vector<int[][]> nets2,double[] motifsWhenRandomized, double[] motifStdDevs, int[][] allData){
return an(nets2,motifsWhenRandomized,motifStdDevs,allData,null,null);
}

public static double[] an(Vector<int[][]> nets2,double[] motifsWhenRandomized, double[] motifStdDevs, int[][] allData,  double[] compRandomMotifCounts, double[] compMotifStdDevs){
//  browseDir(whatDir,nets2,false,false,false,  compRandomMotifCounts,compMotifStdDevs);
System.out.println("The average network density is: "+getAvgDensity(nets2));
doModularityAnalysis(nets2);
double[] resMotifs=new double[(int)Math.pow(2,subnetsize*subnetsize)]; //(2^(3*3))= all cases
int i=0;
int watchCount=0;
int watchNotFound=0;
int[][] tmo;
if(allData!=null)
  tmo=allData;
else
  tmo=new int[nets2.size()][(int)Math.pow(2,subnetsize*subnetsize)];
for(int[][] nework: nets2){
 watchCount=0;
 for(int[][] newrk: network.getAllNbyNsubMatrices(subnetsize,nework))
  if(!badSubNet(newrk))
   {
   int t=network.getCanonicalInt(newrk);
   if(t==watchForThisCanonic){
     watchCount++;
     }
   tmo[i][t]++;               //record also every single detail for std.dev. calculation
   resMotifs[t]++;
   if(watchForThisCanonic>0){
    if(watchCount>0)
     System.out.println("Found pattern "+watchForThisCanonic+" "+watchCount+" times in net "+i);
    else
     watchNotFound++;
    }
   }
 i++;
 }
System.out.println("Pattern "+watchForThisCanonic+" was not found in "+watchNotFound+" nets!");
if(motifsWhenRandomized!=null){
 for(int[][] newo: nets2){
  int[][] nework=network.randomizeConnectivityMatrix(newo);
  for(int[][] newrk: network.getAllNbyNsubMatrices(subnetsize,nework))
   if(!badSubNet(newrk)){
    int t=network.getCanonicalInt(newrk);
    motifsWhenRandomized[t]++; //this is good for the sum (average)
   }
  }
 }
if(motifStdDevs!=null){
  for(int j=0;j<motifStdDevs.length;j++){
   double sigma=0;
   for(int k=0;k<nets2.size();k++){
    double diff=tmo[k][j]-(resMotifs[j]/((double)nets2.size()));
    sigma+=diff*diff;
    }
   motifStdDevs[j]=Math.sqrt(sigma/(double)nets2.size());
   }
  }

/*for(int moti=0;moti<motifStdDevs.length;moti++){
 int motiCnt=0;
 System.out.print(moti + "  " + resMotifs[moti]+ "  ");
 for(int j=0;j<nets2.size();j++)
  motiCnt+=tmo[j][moti];
 System.out.println(motiCnt);
}*/

for(int j=0;j<resMotifs.length;j++){ //get averages, i.e. divide by number of networks
  resMotifs[j]/=(double)nets2.size();
  if(motifsWhenRandomized!=null)
    motifsWhenRandomized[j]/=(double)nets2.size();
  }

 return resMotifs; 
}

public static void writeMotifDistribution(double[] res, double[] stdDevs, int[] motifMappings, String filename){
File file = null;
PrintWriter out = null;
try{
  file = new File(filename);
  out = new PrintWriter(
	new OutputStreamWriter(
	new FileOutputStream(file)));
}
catch(Exception e){
  System.err.println("Error creating output file!\n"+e);
}
for(int i=0;i<motifMappings.length;i++)
 if(motifMappings[i]>0){
  out.println(motifMappings[i]+" "+res[i]+" "+stdDevs[i]+" #"+i);
  //network.printConnectivityMatrix(network.canonicalIntToConnMat(i,subnetsize*subnetsize));
  }
out.close();
}

public static void addShowMotifs(double[] res,boolean[] showMotifs,double cutOffValue){
for(int i=0;i<res.length;i++)
 if(res[i]>cutOffValue)
  showMotifs[i]=true;
}

public static void writeForStatistics(int[][] tmo1, int[][] tmo2, int[] motifMappings, String filename){
File file = null;
PrintWriter out = null;
try{
  file = new File(filename);
  out = new PrintWriter(
	new OutputStreamWriter(
	new FileOutputStream(file)));
}
catch(Exception e){
  System.err.println("Error creating output file!\n"+e);
}
for(int i=0;i<tmo1.length;i++){        //nets
  for(int j=0;j<motifMappings.length;j++){ //motifs
    if(motifMappings[j]>0){
      out.print(tmo1[i][j]+","+tmo2[i][j]+",");
      }
    }
  out.println();
  }
//tmo1[nets][motif]
out.close();
}

public static void doComparisons(Vector<int[][]> nets){
double[][] res=new double[6][];
double[][] randRes=new double[6][];
double[][] stdDevRes=new double[6][];
int[][][] allData=new int[6][80][(int)Math.pow(2,subnetsize*subnetsize)];

for(int i=0;i<randRes.length;i++)
  randRes[i]=new double[(int)Math.pow(2,subnetsize*subnetsize)];
for(int i=0;i<stdDevRes.length;i++)
  stdDevRes[i]=new double[(int)Math.pow(2,subnetsize*subnetsize)];

       //res[0]=an(new File("checkThese/GRN_750Run_twoFuncsNew_slowShift2"),randRes[0],stdDevRes[0]);
//res[2]=an(new File("checkThese/GRN_RandFit750Run_twoFuncsNew_slowShift"),randRes[2],stdDevRes[2],allData[2]);
//res[0]=an(new File("checkThese/GRN_750Run_twoFuncsNew_slowShift"),randRes[0],stdDevRes[0],allData[0],   res[2],stdDevRes[2]);
       //res[2]=an(new File("attractor/attractor_slowShift"),randRes[2],stdDevRes[2]);
       //res[3]=an(new File("checkThese/original750Run"),randRes[3],stdDevRes[3]);





/*
res[0]=an(new File("checkThese/original750Run"),randRes[0],stdDevRes[0]);
genSearchLimit=498;
res[2]=an(new File("checkThese/original750Run"),randRes[2],stdDevRes[2]);
compare(res[0],res[2],randRes[0],subnetsize);
System.exit(0);
*/


res[2]=an(nets,randRes[2],stdDevRes[2],allData[2]);//RandomFit
res[0]=an(nets,randRes[0],stdDevRes[0],allData[0],   res[2],stdDevRes[2]);
double cutOffValue=0.2; //motif occurences smaller than this will be considered irrelevant
boolean[] showMotifs=new boolean[(int)Math.pow(2,subnetsize*subnetsize)];
for(int i=0;i<showMotifs.length;i++)
  showMotifs[i]=false;
addShowMotifs(res[0],showMotifs,cutOffValue);//if at least in one of these data sets an occurence level
addShowMotifs(res[2],showMotifs,cutOffValue);//above cutOffValue is found we show it
//begin numberShowingMotifs
int[] motifMappings=new int[(int)Math.pow(2,subnetsize*subnetsize)];
int mapNum=10;
for(int i=0;i<showMotifs.length;i++)
 if(showMotifs[i]){
  motifMappings[i]=mapNum;
  mapNum=mapNum+10;
  }
//end numberShowingMotifs
writeMotifDistribution(res[0],stdDevRes[0],motifMappings,"test1.txt");
writeMotifDistribution(res[2],stdDevRes[2],motifMappings,"test2.txt");

writeForStatistics(allData[0],allData[2],motifMappings,"stats.txt");
compare(res[0],res[2],stdDevRes[2],subnetsize);


//watchForThisCanonic=118;
//res[0]=an(new File("checkThese/original750Run"),randRes[0],stdDevRes[0]);
//res[1]=an(new File("checkThese/original750Run.2nd"),randRes[1],stdDevRes[1]);

//watchForThisCanonic=-1;
//res[2]=an(new File("checkThese/originalRandomFit750Run"),randRes[2],stdDevRes[2]);

//compare(res[0],res[2],stdDevRes[2],subnetsize);
/*double resSum=0;
double randResSum=0;
double stdDevSum=0;
for(int i=0;i<res[0].length;i++){
  System.out.println(res[0][i]+"  "+randRes[0][i]+"  "+stdDevRes[0][i]);
  resSum+=res[0][i];
  randResSum+=randRes[0][i];
  stdDevSum+=stdDevRes[0][i];
  }
System.out.println(resSum+"        "+randResSum+"        "+stdDevSum);
*/
//res[0]=an(new File("checkThese/GRN_750Run_twoFuncsNew_slowShift2"),randRes[0],stdDevRes[0]);
//res[2]=an(new File("checkThese/GRN_RandFit750Run_twoFuncsNew_slowShift"),randRes[2]);

//compare(res[0],randRes[0],subnetsize);

}

public static void doComparisonsOld(Vector<int[][]> nets){
double[] motifCount=new double[(int)Math.pow(2,subnetsize*subnetsize)]; //(2^(3*3))= all cases

int[] motifNotFound=new int[motifCount.length];
for(int[][] nework: nets){
 int z=0;
 boolean[] motifNotFoundTrack=new boolean[motifCount.length];
 for(int i=0;i<motifNotFoundTrack.length;i++)
  motifNotFoundTrack[i]=true;
 for(int[][] newrk: network.getAllNbyNsubMatrices(subnetsize,nework)){
  int t=network.getCanonicalInt(newrk);
  if(t==watchForThisCanonic){
   z++;
   network.printConnectivityMatrix(newrk,true);
   }
  motifCount[t]++;
  motifNotFoundTrack[t]=false;
  }
 if((watchForThisCanonic>=0))
   System.out.println("Subnetwork "+watchForThisCanonic+" found "+z+" times!");
 for(int i=0;i<motifNotFound.length;i++)
   if(motifNotFoundTrack[i]) //this subnetwork was not found at all in this net
     motifNotFound[i]++;
 }
for(int i=0;i<motifNotFound.length;i++)
  if((motifNotFound[i]<50)||(i==watchForThisCanonic)){
    network.printConnectivityMatrix(network.canonicalIntToConnMat(i,subnetsize*subnetsize));
    System.out.println("above (canoncial number "+i+") was not found in "+motifNotFound[i]+" nets.");
    }

//do counting for randomized nets
double[] motifCountRand=new double[(int)Math.pow(2,subnetsize*subnetsize)]; //(2^(3*3))= all cases
for(int[][] newo: nets){
 int[][] nework=network.randomizeConnectivityMatrix(newo);
 for(int[][] newrk: network.getAllNbyNsubMatrices(subnetsize,nework)){
  int t=network.getCanonicalInt(newrk);
  motifCountRand[t]++;
  }
 }
//compare(motifCount,motifCountRand,subnetsize);
}

public static void allSubnetsTest(){
network nework=new network(5);
nework.addNodes(5);
nework.link(0,1);
nework.link(0,2);
nework.link(0,3);
nework.link(0,4);
nework.link(2,2);
nework.link(3,4);
 for(int[][] newrk: network.getAllNbyNsubMatrices(subnetsize,nework.getConnectivityMatrixArray(true))){
  network.printConnectivityMatrix(newrk);
  }
}

public main(netConverter[] inNets){
Vector<int[][]> nets=new Vector<int[][]>();
network x;
for(netConverter netConv: inNets){
  x=netConv.getNetwork();
  nets.add(x.getConnectivityMatrixArray(considerInhibitory));
  }
doComparisons(nets);
}

public main(Vector<int[][]> inNets){
doComparisons(inNets);
}

public static void main(String[] args){
//modularityTest();
//allSubnetsTest();
Vector<int[][]> nets=new Vector<int[][]>();
System.err.println("YOU HAVE TO PROVIDE YOUR NETWORKS HERE IN ARRAY FORM");
main temp=new main(nets);
}

} 
